/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.127 by jmc, Thu Jun 4 23:40:53 2009 UTC revision 1.152 by jmc, Fri Dec 17 17:32:24 2010 UTC
# Line 13  usage() Line 13  usage()
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14      echo "  (-mth)                   run multi-threaded (using eedata.mth)"      echo "  (-mth)                   run multi-threaded (using eedata.mth)"
15      echo "  (-mpi)                   compile and run using MPI"      echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"      echo "  (-ieee/-noieee)          if possible, use IEEE compiler flags"
17      echo "                             (DEF=\"-ieee\")"      echo "                             (DEF=\"-ieee\")"
18      echo "  (-gsl)                   compile with \"-gsl\" flag"      echo "  (-gsl)                   compile with \"-gsl\" flag"
19      echo "  (-of=|-optfile=)STRING   list of optfiles to use"      echo "  (-use_r4|-ur4)           if allowed, use real*4 type for '_RS' variable"
20      echo "  (-a|-addr) STRING        list of email recipients"      echo "  (-optfile|-of) STRING    list of optfiles to use"
21        echo "  (-addr|-a) STRING        list of email recipients"
22      echo "                             (DEF=\"\" no email is sent)"      echo "                             (DEF=\"\" no email is sent)"
23      echo "  (-mpd|-mpackdir) DIR     location of the mpack utility"      echo "  (-mpackdir|-mpd) DIR     location of the mpack utility"
24      echo "                             (DEF=\"../tools/mpack-1.6\")"      echo "                             (DEF=\"../tools/mpack-1.6\")"
25      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"      echo "  (-tdir|-t) STRING        list of group and/or exp. dirs to test"
26      echo "                             (recognized groups: basic, tutorials)"      echo "                             (recognized groups: basic, tutorials)"
27      echo "                             (DEF=\"\" which test all)"      echo "                             (DEF=\"\" which test all)"
28      echo "  (-skd|-skipdir) STRING   list of exp. dirs to skip"      echo "                             (if list= 'start_from THIS_EXP' then"
29        echo "                              test THIS_EXP + all the following)"
30        echo "  (-skipdir|-skd) STRING   list of exp. dirs to skip"
31      echo "                             (DEF=\"\" which test all)"      echo "                             (DEF=\"\" which test all)"
32      echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"      echo "  (-bash|-b) STRING        preferred location of a \"bash\" or"
33      echo "                             Bourne-compatible \"sh\" shell"      echo "                             Bourne-compatible \"sh\" shell"
34      echo "                             (DEF=\"\" for \"bash\")"      echo "                             (DEF=\"\" for \"bash\")"
35      echo "  (-adm|-ad)               perform an adjoint run"      echo "  (-adm|-ad)               perform an adjoint run"
36      echo "  (-oad)                   perform an OpenAD adjoint run"      echo "  (-oad)                   perform an OpenAD adjoint run"
37      echo "  (-command) STRING        command to run"      echo "  (-command|-c) STRING     command to run"
38      echo "                             (DEF=\"make output.txt\")"      echo "  (-makedepend|-md) STRING command to use for \"makedepend\""
39      echo "  (-m|-make) STRING        command to use for \"make\""      echo "  (-make|-m) STRING        command to use for \"make\""
40      echo "                             (DEF=\"make\")"      echo "                             (DEF=\"make\")"
41      echo "  (-odir) STRING           used to build output directory name"      echo "  (-odir) STRING           used to build output directory name"
42      echo "                             (DEF=\"hostname\")"      echo "                             (DEF=\"hostname\")"
43      echo "  (-ptr|-ptracers) STRING  specify which ptracers to test"      echo "  (-ptracers|-ptr) STRING  specify which ptracers to test"
44      echo "                             (DEF=\"1 2 3 4 5\")"      echo "                             (DEF=\"1 2 3 4 5\")"
45      echo "  (-match) NUMBER          Matching Criteria (number of digits)"      echo "  (-match) NUMBER          Matching Criteria (number of digits)"
46      echo "                             (DEF=\"12\")"      echo "                             (DEF=\"$MATCH_CRIT\")"
47      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
48      echo "  (-clean)                 *ONLY* run \"make CLEAN\""      echo "  (-clean)                 *ONLY* run \"make CLEAN\""
49        echo "  (-norun|-nr)             skip the \"runmodel\" stage (stop after make)"
50        echo "  (-runonly|-ro)           *ONLY* run stage (=\"-quick\" without make)"
51      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
52      echo "  (-nogenmake|-ng)         skip the genmake stage"      echo "  (-nogenmake|-ng)         skip the genmake stage"
53      echo "  (-noclean|-nc)           skip the \"make clean\" stage"      echo "  (-noclean|-nc)           skip the \"make clean\" stage"
# Line 104  testoutput_var() Line 109  testoutput_var()
109  {  {
110      # testoutput_var dir s1 label subdir reference_output      # testoutput_var dir s1 label subdir reference_output
111      #      #
112      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
113      #     with same output from reference file $dir/results/$reference_output      #     with same output from reference file $dir/results/$reference_output
114      #  using search strings s1 and text label      #  using search strings s1 and text label
115    
# Line 176  testoutput_var() Line 181  testoutput_var()
181          fi          fi
182      fi      fi
183      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
184        
185      return $digits_of_similarity      return $digits_of_similarity
186  }  }
187    
# Line 229  testoutput_run() Line 234  testoutput_run()
234            listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`            listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`
235          fi          fi
236          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi
237          echo "listVar='$listVar'" > $CDIR"/summary.txt"          echo "listVar='$listVar'" > $locDIR"/summary.txt"
238          allargs=""          allargs=""
239          for xx in $listVar          for xx in $listVar
240          do          do
# Line 264  testoutput_run() Line 269  testoutput_run()
269             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
270          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
271             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;
272           'Qntmn') testoutput_var $1 "extforcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;           'Qntmn') testoutput_var $1 "forcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;
273           'Qntmx') testoutput_var $1 "extforcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;           'Qntmx') testoutput_var $1 "forcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;
274           'Qntav') testoutput_var $1 "extforcing_qnet_mean" "Qnet mean"    $2 $3; yy=$? ;;           'Qntav') testoutput_var $1 "forcing_qnet_mean" "Qnet mean"       $2 $3; yy=$? ;;
275           'Qntsd') testoutput_var $1 "extforcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;           'Qntsd') testoutput_var $1 "forcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;
276           'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;           'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;
277           'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;           'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;
278           'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;           'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;
# Line 291  testoutput_run() Line 296  testoutput_run()
296          done          done
297    
298          nbVar=`echo $listVar | awk '{print NF}'`          nbVar=`echo $listVar | awk '{print NF}'`
299          if [ $nbVar -lt $LEN_CHECK_LIST ] ; then          if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
300          #-- fill line (up to standard length) with dot:          #-- fill line (up to standard length) with dot:
301            adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`            adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
302            echo $allargs $adNul            echo $allargs $adNul
303          else          else
304            echo $allargs            echo $allargs
305          fi          fi
306  # <-- same processing for adjoint & forward test  # <-- same processing for adjoint & forward test
307  }  }
308    
# Line 315  genmakemodel() Line 320  genmakemodel()
320          (          (
321              cd $1;              cd $1;
322              command="$GENMAKE2  -ds -m $MAKE"              command="$GENMAKE2  -ds -m $MAKE"
323                if test "x$MKDEPEND" != x ; then
324                    command="$command -makedepend=$MKDEPEND"
325                fi
326              if test "x$ADM" = xt ; then              if test "x$ADM" = xt ; then
327                  command="$command --mods=../code_ad"                  command="$command --mods=../code_ad"
328              elif test "x$OADM" = xt ; then              elif test "x$OADM" = xt ; then
# Line 338  genmakemodel() Line 346  genmakemodel()
346              #- run multi-threaded using OpenMP:              #- run multi-threaded using OpenMP:
347                  command="$command -omp"                  command="$command -omp"
348              fi              fi
349                if test "x$USE_R4" = xt ; then
350                    command="$command -use_r4"
351                fi
352              if test "x$TS" = xt ; then              if test "x$TS" = xt ; then
353                  command="$command -ts"                  command="$command -ts"
354              fi              fi
355              if test "x$PAPIS" = xt ; then              if test "x$PAPIS" = xt ; then
356                  command="$command -papis"                  command="$command -papis"
357              else              else
358              if test "x$PCLS" = xt ; then              if test "x$PCLS" = xt ; then
359                  command="$command -pcls"                  command="$command -pcls"
360              fi              fi
361              fi              fi
362              printf 'genmake ... ' 1>&2              printf 'genmake ... '
363              # $command > make.log 2>&1              eval $command > genmake.tr_log 2>&1
             eval $command > make.log 2>&1  
364              RETVAL=$?              RETVAL=$?
365              #  Reduce the size of the testing emails!              #  Reduce the size of the testing emails!
366              head -100 Makefile > $CDIR/Makefile_head              head -100 Makefile > $CDIR/Makefile_head
367              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
368                  tail make.log                  tail genmake.tr_log
369                  echo "genmakemodel: genmake failed" 1>&2                  echo "genmakemodel: genmake failed"
370                  cp genmake_* make.log $CDIR                  cp genmake.log genmake_* genmake.tr_log $CDIR
371                  return 1                  return 1
372              else              else
373                  echo "successful" 1>&2                  echo "successful"
374              fi              fi
375          )          )
376      fi      fi
# Line 369  genmakemodel() Line 379  genmakemodel()
379  makeclean()  makeclean()
380  {  {
381      # makeclean directory      # makeclean directory
382        if test "x$NODEPEND" = xf ; then rm -f $1/make.tr_log ; fi
383      if test "x$NOCLEAN" = xt ; then      if test "x$NOCLEAN" = xt ; then
384          echo "make Clean skipped!"          echo "make Clean skipped!"
385      else      else
# Line 376  makeclean() Line 387  makeclean()
387              cd $1;              cd $1;
388              #if test -e $OUTPUTFILE ; then rm -f $OUTPUTFILE ; fi              #if test -e $OUTPUTFILE ; then rm -f $OUTPUTFILE ; fi
389              if test -r Makefile ; then              if test -r Makefile ; then
390                  printf 'clean build-dir: make Clean ... ' 2>&1                  printf 'clean build-dir: make Clean ... '
391                  $MAKE Clean >> make.log 2>&1                  rm -f Makefile.old
392                    $MAKE Clean >> make.tr_log 2>&1
393                  RETVAL=$?                  RETVAL=$?
394                  if test "x$RETVAL" != x0 ; then                  if test "x$RETVAL" != x0 ; then
395                      tail make.log                      tail make.tr_log
396                      echo "makeclean: \"make Clean\" failed" 1>&2                      echo "makeclean: \"make Clean\" failed"
397                      cp make.log $CDIR"/make.log"                      cp make.tr_log genmake.log genmake.tr_log $CDIR
398                      return 1                      return 1
399                  fi                  fi
400                  echo successful 1>&2                  echo successful
401              else              else
402                  echo ''                  echo ''
403              fi              fi
# Line 402  run_clean() Line 414  run_clean()
414      else      else
415          (          (
416              cd $1;              cd $1;
417              printf 'clean run-dir ... ' 2>&1              printf 'clean run-dir ... '
418              # part of what is done after "make clean" when doing "make CLEAN"              # part of what is done after "make clean" when doing "make CLEAN"
419              find . -name "*.meta" -exec rm {} \;              find . -name "*.meta" -exec rm {} \;
420              find . -name "*.data" -exec rm {} \;              find . -name "*.data" -exec rm {} \;
421              find . -name "fort.*" -exec rm {} \;              find . -name "fort.*" -exec rm {} \;
422              find . -type l -exec rm {} \;              find . -type l -exec rm {} \;
423              rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime              rm -f $EXECUTABLE $RUNLOG *.txt STD* *diagnostics.log datetime
424              rm -rf mnc_test_*              rm -rf mnc_test_*
425              rm -f *_MIT_CE_000.opt0000 costfunction*0000              rm -f *_MIT_CE_000.opt0000 costfunction*0000
426              echo successful 1>&2              echo successful
427              exit 0              exit 0
428          )          )
429      fi      fi
# Line 425  makedependmodel() Line 437  makedependmodel()
437      else      else
438          (          (
439              cd $1;              cd $1;
440              printf 'make depend ... ' 1>&2              printf 'make depend ... '
441              $MAKE depend >> make.log 2>&1              $MAKE depend >> make.tr_log 2>&1
442              RETVAL=$?              RETVAL=$?
443              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
444                  tail make.log                  tail make.tr_log
445                  echo "makedependmodel: make depend failed" 1>&2                  echo "makedependmodel: make depend failed"
446                  cp make.log $CDIR"/make.log"                  cp make.tr_log genmake.log genmake.tr_log $CDIR
447                  return 1                  return 1
448              else              else
449                  echo successful 1>&2                  echo successful
450              fi              fi
451          )          )
452      fi      fi
# Line 444  makemodel() Line 456  makemodel()
456  {  {
457      # makemodel directory      # makemodel directory
458      (      (
459        if test "x$NOMAKE" = xt ; then
460            cd $1;
461            if test -x $EXECUTABLE ; then
462                echo "make skipped!"
463            else
464                echo "no executable!"
465                return 2
466            fi
467        else
468          cd $1;          cd $1;
469          if test -r Makefile ; then          if test -r Makefile ; then
470              printf 'make ... ' 1>&2              printf 'make ... '
471              if test "x$ADM" = xt ; then              if test "x$ADM" = xt ; then
472                  $MAKE adall >> make.log 2>&1                  $MAKE adall >> make.tr_log 2>&1
473              elif test "x$OADM" = xt ; then              elif test "x$OADM" = xt ; then
474                  $MAKE adAll >> make.log 2>&1                  $MAKE adAll >> make.tr_log 2>&1
475              else              else
476                  if test "x$JOBS" = x ; then                  if test "x$JOBS" = x ; then
477                      $MAKE >> make.log 2>&1                      $MAKE >> make.tr_log 2>&1
478                  else                  else
479                      $MAKE -j $JOBS >> make.log 2>&1                      $MAKE -j $JOBS >> make.tr_log 2>&1
480                  fi                  fi
481              fi              fi
482              RETVAL=$?              RETVAL=$?
483              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
484                  tail make.log                  tail make.tr_log
485                  echo failed 1>&2                  echo failed
486                  cp make.log $CDIR"/make.log"                  cp make.tr_log genmake.log genmake.tr_log $CDIR
487                    rm -f $EXECUTABLE
488                  return 1                  return 1
489              else              else
490                  echo successful 1>&2                  echo successful
491              fi              fi
492          fi          fi
493        fi
494      )      )
495  }  }
496    
# Line 481  symlink_mpifiles() Line 504  symlink_mpifiles()
504      code_dir=$2      code_dir=$2
505      BUILD_DIR=$dir/$3      BUILD_DIR=$dir/$3
506      CODE_DIR=$dir/$code_dir      CODE_DIR=$dir/$code_dir
507        
508      # These are files that should replace their counter-part when using -mpi      # These are files that should replace their counter-part when using -mpi
509      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`
510    
# Line 516  symlink_mpifiles() Line 539  symlink_mpifiles()
539              fi              fi
540          done          done
541      fi      fi
542        
543  }  }
544    
545  linkdata()  linkdata()
# Line 527  linkdata() Line 550  linkdata()
550      if test -d $1 ; then      if test -d $1 ; then
551          (          (
552              cd $1 ; shift              cd $1 ; shift
553                echo 'linkdata from dirs:' $*
554              inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`              inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`
555              for xx in $inpMPI ; do              for xx in $inpMPI ; do
556                if test -r "../"$1"/"$xx ; then                if test -r "../"$1"/"$xx ; then
# Line 535  linkdata() Line 559  linkdata()
559                  if test "x$MPI" = "xt" ; then                  if test "x$MPI" = "xt" ; then
560                  # mpi test: remove symbolic link & link _mpi sfx file                  # mpi test: remove symbolic link & link _mpi sfx file
561                      if test -h $yy ; then rm -f $yy ; fi                      if test -h $yy ; then rm -f $yy ; fi
562                      if test ! -r $yy ; then                      if test ! -r $yy ; then
563                          ln -sf "../"$1"/"$xx $yy ;                          ln -sf "../"$1"/"$xx $yy ;
564                          printf "$xx " 1>&2                          printf " $xx" 1>&2
565                      fi                      fi
566                  else                  else
567                  # not mpi test: remove symbolic link                  # not mpi test: remove symbolic link
# Line 550  linkdata() Line 574  linkdata()
574                  if test "x$MULTI_THREAD" = "xt" ; then                  if test "x$MULTI_THREAD" = "xt" ; then
575                  # multi-threaded test: remove symbolic link & link eedata.mth                  # multi-threaded test: remove symbolic link & link eedata.mth
576                      if test -h eedata ; then rm -f eedata ; fi                      if test -h eedata ; then rm -f eedata ; fi
577                      if test ! -r eedata ; then                      if test ! -r eedata ; then
578                          ln -sf "../"$1"/eedata.mth" eedata ;                          ln -sf "../"$1"/eedata.mth" eedata ;
579                          printf 'eedata.mth ' 1>&2                          printf ' eedata.mth' 1>&2
580                      fi                      fi
581                  else                  else
582                  # not multi-threaded test: remove eedata symbolic link                  # not multi-threaded test: remove eedata symbolic link
# Line 562  linkdata() Line 586  linkdata()
586              prevDir='NONE'              prevDir='NONE'
587              for ldir in $* ; do              for ldir in $* ; do
588                  if test -d "../"$ldir -a $ldir != $prevDir ; then                  if test -d "../"$ldir -a $ldir != $prevDir ; then
589                      printf 'ldir='${ldir} 1>&2                      printf " ldir=${ldir}:" 1>&2
590                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
591                      for i in $files ; do                      for i in $files ; do
592                          if test ! -d "../"$ldir/$i ; then                          if test ! -d "../"$ldir/$i ; then
# Line 572  linkdata() Line 596  linkdata()
596                              fi                              fi
597                          fi                          fi
598                      done                      done
599                        printf ' ;' 1>&2
600                      if test -x "../"$ldir"/"prepare_run ; then                      if test -x "../"$ldir"/"prepare_run ; then
601                          "../"$ldir"/"prepare_run                          "../"$ldir"/"prepare_run 1>&2
602                        else
603                            echo '' 1>&2
604                      fi                      fi
                     printf ' ; ' 1>&2  
605                  fi                  fi
606                  prevDir=$ldir                  prevDir=$ldir
607              done              done
# Line 587  runmodel() Line 613  runmodel()
613  {  {
614      # runmodel directory      # runmodel directory
615      #      #
616      #  runs "$COMMAND in "directory"      #  runs "$COMMAND in "directory"
617      #  (where "$COMMAND" is relative to "directory")      #  (where "$COMMAND" is relative to "directory")
618      (      (
619          cd $1          cd $1
620          printf 'runmodel in %s ...' $1 1>&2          printf 'runmodel in %s ... ' $1
621          # make output.txt          if test -L $EXECUTABLE ; then
622          echo            if test -x "../"$builddir"/"$EXECUTABLE ; then
         if test -L $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then  
623              diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1              diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1
624              outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; fi              outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; fi
625              else rm -f $EXECUTABLE
626              fi
627          fi          fi
628          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
629              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp
# Line 620  runmodel() Line 647  runmodel()
647                  if test -f $RUNLOG ; then                  if test -f $RUNLOG ; then
648                      if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi                      if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
649                      echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1                      echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
650                  else                  else
651                      touch $RUNLOG                      touch $RUNLOG
652                      if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi                      if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
653                      echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1                      echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
# Line 630  runmodel() Line 657  runmodel()
657              ENDVAL=`cat $RUNLOG | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`              ENDVAL=`cat $RUNLOG | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`
658          fi          fi
659          rm -f run.log_tmp          rm -f run.log_tmp
         #if test "x$RETVAL" = x0 ; then  
660          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
661              tail $RUNLOG              echo successful
662              echo successful 1>&2              printf '=> output from running in %s :\n' $1 1>&2
663                tail $RUNLOG | sed 's/^.*/> &/g' 1>&2
664              # === Reduce the size of the testing emails!              # === Reduce the size of the testing emails!
665              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE
666              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
667              return 0              return 0
668            elif [ $RETVAL -ne 0 -a $ENDVAL -gt 0 ] ; then
669                #-- for some weird cases (run is finihed but with error code)
670                echo 'finished with error (run:' $RETVAL ' end:' $ENDVAL ')'
671                printf '=> output from running in %s :\n' $1 1>&2
672                tail $RUNLOG | sed 's/^.*/> &/g' 1>&2
673                return 0
674          else          else
675              tail $RUNLOG              echo 'failed (run:' $RETVAL ' end:' $ENDVAL ')'
676              echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2              printf '=> output from running in %s :\n' $1 1>&2
677                tail $RUNLOG | sed 's/^.*/> &/g' 1>&2
678              cp $RUNLOG $CDIR"/"$RUNLOG              cp $RUNLOG $CDIR"/"$RUNLOG
679              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
680              return 1              return 1
# Line 692  EOF Line 726  EOF
726          return 0          return 0
727      else      else
728          echo          echo
729          echo "ERROR: failed to compile comparison code -- please specify"          echo "ERROR: failed to compile comparison code -- please specify"
730          echo "  a C compiler using the CC environment variable."          echo "  a C compiler using the CC environment variable."
731          exit 1          exit 1
732      fi      fi
# Line 711  formatresults() Line 745  formatresults()
745      printf '%3s' $listPrt      printf '%3s' $listPrt
746  #   line below does not work on hp-ux_ia64 : do those substitutions later on  #   line below does not work on hp-ux_ia64 : do those substitutions later on
747  #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'  #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'
748        
749      if [ $xx = '..' ]; then      if [ $xx = '..' ]; then
750          printf ' N/O '          printf ' N/O '
751      elif [ $xx = '--' ]; then      elif [ $xx = '--' ]; then
# Line 727  formatresults() Line 761  formatresults()
761      fi      fi
762      printf '  %s' $nm      printf '  %s' $nm
763      printf '\n'      printf '\n'
764        
765  }  }
766    
767  scandirs()  scandirs()
# Line 786  fi Line 820  fi
820  GSL=f  GSL=f
821    
822  CLEANUP=f  CLEANUP=f
823    NORUN=f
824  QUICK=f  QUICK=f
825    NOMAKE=f
826  NOGENMAKE=f  NOGENMAKE=f
827  NOCLEAN=f  NOCLEAN=f
828  NODEPEND=f  NODEPEND=f
# Line 801  MPACKDIR="../tools/mpack-1.6" Line 837  MPACKDIR="../tools/mpack-1.6"
837  HAVE_MPACK=  HAVE_MPACK=
838  MPACK=  MPACK=
839  COMMAND=  COMMAND=
840    MKDEPEND=
841  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
842      MAKE=make      MAKE=make
843  fi  fi
# Line 812  MPI=f Line 849  MPI=f
849  MULTI_THREAD=f  MULTI_THREAD=f
850  OUTDIR=  OUTDIR=
851  DELDIR=  DELDIR=
852    USE_R4=
853    
854  ADM=  ADM=
855  OADM=  OADM=
# Line 819  OADM= Line 857  OADM=
857  # list of pTracers to check for monitor output  # list of pTracers to check for monitor output
858  PTRACERS_NUM="1 2 3 4 5"  PTRACERS_NUM="1 2 3 4 5"
859    
860  MATCH_CRIT=13  MATCH_CRIT=10
861    
862  printf "parsing options...  "  printf "parsing options...  "
863    
# Line 834  for ac_option ; do Line 872  for ac_option ; do
872      fi      fi
873    
874      ac_optarg=`expr "x$ac_option" : 'x[^=]*=\(.*\)'`      ac_optarg=`expr "x$ac_option" : 'x[^=]*=\(.*\)'`
875        
876      case $ac_option in      case $ac_option in
877                    
878          -help | --help | -h | --h)          -help | --help | -h | --h)
# Line 847  for ac_option ; do Line 885  for ac_option ; do
885                    
886          -addr | --addr | -a | --a)          -addr | --addr | -a | --a)
887              ac_prev=ADDRESSES ;;              ac_prev=ADDRESSES ;;
888          -addr=* | --addr=*)          -addr=* | --addr=* | -a=* | --a=*)
889              ADDRESSES=$ac_optarg ;;              ADDRESSES=$ac_optarg ;;
890          -mpackdir | --mpackdir | -mpd | --mpd)          -mpackdir | --mpackdir | -mpd | --mpd)
891              ac_prev=MPACKDIR ;;              ac_prev=MPACKDIR ;;
# Line 856  for ac_option ; do Line 894  for ac_option ; do
894    
895          -tdir | --tdir | -t | --t)          -tdir | --tdir | -t | --t)
896              ac_prev=TESTDIRS ;;              ac_prev=TESTDIRS ;;
897          -tdir=* | --tdir=*)          -tdir=* | --tdir=* | -t=* | --t=*)
898              TESTDIRS=$ac_optarg ;;              TESTDIRS=$ac_optarg ;;
899    
900          -skipdir | --skipdir | -skd | --skd)          -skipdir | --skipdir | -skd | --skd)
901              ac_prev=SKIPDIRS ;;              ac_prev=SKIPDIRS ;;
902          -skipdir=* | --skipdir=*)          -skipdir=* | --skipdir=* | -skd=* | --skd=*)
903              SKIPDIRS=$ac_optarg ;;              SKIPDIRS=$ac_optarg ;;
904    
905          -bash | --bash | -b | --b)          -bash | --bash | -b | --b)
906              ac_prev=BASH ;;              ac_prev=BASH ;;
907          -bash=* | --bash=*)          -bash=* | --bash=* | -b=* | --b=*)
908              BASH=$ac_optarg ;;              BASH=$ac_optarg ;;
909    
910          -command | --command | -c | --c)          -command | --command | -c | --c)
911              ac_prev=COMMAND ;;              ac_prev=COMMAND ;;
912          -command=* | --command=*)          -command=* | --command=* | -c=* | --c=*)
913              COMMAND=$ac_optarg ;;              COMMAND=$ac_optarg ;;
914    
915            -makedepend | --makedepend | -md | --md)
916                ac_prev=MKDEPEND ;;
917            -makedepend=* | --makedepend=* | -md=* | --md=*)
918                MKDEPEND=$ac_optarg ;;
919    
920          -make | --make | -m | --m)          -make | --make | -m | --m)
921              ac_prev=MAKE ;;              ac_prev=MAKE ;;
922          -make=* | --make=*)          -make=* | --make=* | -m=* | --m=*)
923              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
924    
925          -odir | --odir)          -odir | --odir)
# Line 892  for ac_option ; do Line 935  for ac_option ; do
935          -match | --match ) ac_prev=MATCH_CRIT ;;          -match | --match ) ac_prev=MATCH_CRIT ;;
936          -match=* | --match=* ) MATCH_CRIT=$ac_optarg ;;          -match=* | --match=* ) MATCH_CRIT=$ac_optarg ;;
937    
938          -j) ac_prev=JOBS ;;          -j | --j) ac_prev=JOBS ;;
939          -j=*) JOBS=$ac_optarg ;;          -j=* | --j=*) JOBS=$ac_optarg ;;
940    
941          -clean | --clean)          -clean | --clean)
942              CLEANUP=t ; DELDIR=t ;;              CLEANUP=t ; DELDIR=t ;;
943    
944            -norun | --norun | -nr | --nr)
945                NORUN=t ;;
946            -runonly | --runonly | -ro | --ro)
947                QUICK=t ; NOMAKE=t ;;
948          -quick | --quick | -q | --q)          -quick | --quick | -q | --q)
949              QUICK=t ;;              QUICK=t ;;
950          -nogenmake | --nogenmake | -ng | --ng)          -nogenmake | --nogenmake | -ng | --ng)
# Line 928  for ac_option ; do Line 975  for ac_option ; do
975    
976          -deldir | -dd) DELDIR=t ;;          -deldir | -dd) DELDIR=t ;;
977    
978          -ts) TS=t;;          -use_r4|-ur4) USE_R4=t ;;
979    
980            -ts) TS=t;;
981          -papis) PAPIS=t;;          -papis) PAPIS=t;;
   
982          -pcls) PCL=t;;          -pcls) PCL=t;;
983    
984          -*)          -*)
985              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
986              usage              usage
987              ;;              ;;
988            
989          *)          *)
990              echo "Error: unrecognized argument: "$ac_option              echo "Error: unrecognized argument: "$ac_option
991              usage              usage
992              ;;              ;;
993            
994       esac       esac
995        
996  done  done
997    
998  if test "x$QUICK" = xt ; then  if test "x$QUICK" = xt ; then
# Line 972  else Line 1019  else
1019      EXECUTABLE="mitgcmuv"      EXECUTABLE="mitgcmuv"
1020  fi  fi
1021    
1022    xx=`echo $TESTDIRS | awk '{print $1}'`
1023  if test "x$TESTDIRS" = x ; then  if test "x$TESTDIRS" = x ; then
1024      LIST=`scandirs results/$ref_outp`      LIST=`scandirs results/$ref_outp`
1025    elif test $xx = 'start_from' ; then
1026        xx=`echo $TESTDIRS | awk '{print $2}'`
1027        LIST=`scandirs results/$ref_outp | sed -n "/$xx/,$ p"`
1028  else  else
1029      #- expand group of experiments:      #- expand group of experiments:
1030      LIST=" "      LIST=" "
# Line 988  else Line 1039  else
1039                   LIST=${LIST}" "`ls | grep 'tutorial_'` ;;                   LIST=${LIST}" "`ls | grep 'tutorial_'` ;;
1040          *)       LIST=${LIST}" "$xx ;;          *)       LIST=${LIST}" "$xx ;;
1041        esac        esac
1042      done      done
1043  fi  fi
1044  #echo 'LIST='${LIST}'<'  #echo 'LIST='${LIST}'<'
1045  #- skip dirs, remove duplicate and non-directory:  #- skip dirs, remove duplicate and non-directory:
# Line 1009  do Line 1060  do
1060          else count=1 ; echo "" ;  echo -n " skip: \"$xx\""          else count=1 ; echo "" ;  echo -n " skip: \"$xx\""
1061          fi          fi
1062      fi      fi
1063  done  done
1064  if test $count = 1 ; then echo "" ; echo -n " ... " ; fi  if test $count = 1 ; then echo "" ; echo -n " ... " ; fi
1065  #echo 'TESTDIRS='${TESTDIRS}'<'  #echo 'TESTDIRS='${TESTDIRS}'<'
1066    
# Line 1017  if test "x$OPTFILE" = xNONE -a "x$MITGCM Line 1068  if test "x$OPTFILE" = xNONE -a "x$MITGCM
1068      OPTFILE=$MITGCM_OF      OPTFILE=$MITGCM_OF
1069  fi  fi
1070    
1071  RUNLOG="run.log"  RUNLOG="run.tr_log"
1072  OUTPUTFILE=$ref_outp  OUTPUTFILE=$ref_outp
1073  if test "x$COMMAND" = x ; then  if test "x$COMMAND" = x ; then
1074      COMMAND="./$EXECUTABLE > $OUTPUTFILE"      COMMAND="./$EXECUTABLE > $OUTPUTFILE"
# Line 1045  else Line 1096  else
1096  fi  fi
1097    
1098  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
1099  createcodelet  if test -x tr_cmpnum ; then
1100        echo "skipping comparison code build"
1101    else
1102        createcodelet
1103    fi
1104    
1105  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)
1106  if test "x$ADDRESSES" = x ; then  if test "x$ADDRESSES" = x ; then
# Line 1111  if test "x$OPTFILE" != xNONE ; then Line 1166  if test "x$OPTFILE" != xNONE ; then
1166      fi      fi
1167  else  else
1168      echo >> $SUMMARY      echo >> $SUMMARY
1169      echo "No \"OPTFILE\" was explicitly specified by testreport," >> $SUMMARY      echo "No \"OPTFILE\" was specified ; genmake2 found and uses:" >> $SUMMARY
1170      echo "   so the genmake default will be used." >> $SUMMARY      #-note: to be filled later after 1rst run
1171  fi  fi
1172  echo  echo
1173  echo >> $SUMMARY  echo >> $SUMMARY
1174  if test "x$ADM" = x -a "x$OADM" = x; then  if test "x$ADM" = x -a "x$OADM" = x; then
1175      if [ $MATCH_CRIT -lt 10 ] ;      if [ $MATCH_CRIT -lt 10 ] ;
1176      then line_0="default  "$MATCH_CRIT ;      then line_0="default  "$MATCH_CRIT ;
1177      else line_0="default "$MATCH_CRIT ; fi      else line_0="default "$MATCH_CRIT ; fi
1178         line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"         line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"
 #   line_0="            ----T-----  ----S-----  ----U-----  ----V-----"  
1179      line_1="G D M    c        m  s        m  s        m  s        m  s"      line_1="G D M    c        m  s        m  s        m  s        m  s"
1180      line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."      line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."
1181      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
# Line 1142  if test "x$ADM" = x -a "x$OADM" = x; the Line 1196  if test "x$ADM" = x -a "x$OADM" = x; the
1196  else  else
1197      echo "ADJOINT=true" >> $SUMMARY      echo "ADJOINT=true" >> $SUMMARY
1198      echo >> $SUMMARY      echo >> $SUMMARY
1199      if [ $MATCH_CRIT -lt 10 ] ;      if [ $MATCH_CRIT -lt 10 ] ;
1200      then line_0="default     "$MATCH_CRIT ;      then line_0="default     "$MATCH_CRIT ;
1201      else line_0="default    "$MATCH_CRIT ; fi      else line_0="default    "$MATCH_CRIT ; fi
1202      echo "$line_0" | tee -a $SUMMARY      echo "$line_0" | tee -a $SUMMARY
1203      cat << EOF | tee -a $SUMMARY      cat << EOF | tee -a $SUMMARY
# Line 1154  N n k u  s  a Line 1208  N n k u  s  a
1208    
1209  EOF  EOF
1210  fi  fi
1211    echo "-------------------------------------------------------------------------------"
1212    
1213  #  ...and each test directory...  #  ...and each test directory...
1214  for dir in $TESTDIRS ; do  for dir in $TESTDIRS ; do
1215        
1216      # set builddir & rundir:      # set builddir & rundir:
1217      builddir="build"      builddir="build"
1218      if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi      if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
1219      rundir="run"      rundir="run"
1220        pfxdir="tr_$rundir"
1221      if test ! -d $dir/$rundir ; then      if test ! -d $dir/$rundir ; then
1222          rundir=$builddir          rundir=$builddir
1223      fi      fi
# Line 1172  for dir in $TESTDIRS ; do Line 1228  for dir in $TESTDIRS ; do
1228      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1229          echo -n '  --- dir:' $BUILD_DIR ': '          echo -n '  --- dir:' $BUILD_DIR ': '
1230          makeclean $BUILD_DIR          makeclean $BUILD_DIR
1231            (   cd $BUILD_DIR
1232                rm -f $EXECUTABLE *.bak
1233                rm -f genmake_state genmake_*optfile genmake.log
1234                rm -f genmake.tr_log make.tr_log
1235            )
1236          if test -d $dir/$rundir/CVS ; then          if test -d $dir/$rundir/CVS ; then
1237              echo -n '  --- dir:' $dir/$rundir ': '              echo -n '  --- dir:' $dir/$rundir ': '
1238              run_clean $dir/$rundir              run_clean $dir/$rundir
1239          fi          fi
1240          trdir=`( cd $dir ; find . -type d -name "tr_run.*" -print | sed 's/^.\///')`          trdir=`( cd $dir ; find . -type d -name "$pfxdir.*" -print | sed 's/^.\///')`
1241          ttd=`echo $trdir | wc -w`          ttd=`echo $trdir | wc -w`
1242          if test $ttd != 0 ; then          if test $ttd != 0 ; then
1243              echo '  --- rm dir:' $trdir              echo '  --- rm dir:' $trdir
# Line 1185  for dir in $TESTDIRS ; do Line 1246  for dir in $TESTDIRS ; do
1246          continue          continue
1247      fi      fi
1248    
1249      #  Verify that the testdir exists and contains previous      #  Verify that the testdir exists and contains previous
1250      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
1251      fout=$dir"/results/"$ref_outp      fout=$dir"/results/"$ref_outp
1252      if test ! -r $fout ; then      if test ! -r $fout ; then
# Line 1213  for dir in $TESTDIRS ; do Line 1274  for dir in $TESTDIRS ; do
1274    
1275      #  Check whether there are "extra runs" for this testdir      #  Check whether there are "extra runs" for this testdir
1276      extra_runs=      extra_runs=
1277      ex_run_dirs=`( cd $dir ; echo $inputdir.* )`      if test "x$NORUN" = xf ; then
1278            ex_run_dirs=`( cd $dir ; echo $inputdir.* )`
1279        fi
1280      #echo "ex_run_dirs='$ex_run_dirs'"      #echo "ex_run_dirs='$ex_run_dirs'"
1281      for exd in $ex_run_dirs ; do      for exd in $ex_run_dirs ; do
1282          name=`echo $exd | sed -e "s/$inputdir\.//"`          name=`echo $exd | sed -e "s/$inputdir\.//"`
1283          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1284          outf="$dir/results/$refExOut"          outf="$dir/results/$refExOut"
1285          if test -f $outf -a -r $outf ; then          if test -f $outf -a -r $outf ; then
1286            if test "x$MULTI_THREAD" = "xt" ; then            if test "x$MULTI_THREAD" = "xt" ; then
1287              if test -r $dir"/"$exd"/eedata.mth" ; then              if test -r $dir"/"$exd"/eedata.mth" ; then
1288                if test "x$MPI" = "xt" ; then                if test "x$MPI" = "xt" ; then
1289                  retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/"$exd"/eedata.mth"`                  retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/"$exd"/eedata.mth"`
# Line 1240  for dir in $TESTDIRS ; do Line 1303  for dir in $TESTDIRS ; do
1303          fi          fi
1304      done      done
1305    
     echo "-------------------------------------------------------------------------------"  
1306      echo      echo
1307      if test "x$extra_runs" = "x" ; then      if test "x$extra_runs" = "x" ; then
1308         echo "Experiment:  $dir"         echo "Experiment:  $dir"
1309      else      else
1310         echo "Experiment:  $dir ; extra_runs=$extra_runs"         echo "Experiment:  $dir ; extra_runs=$extra_runs"
# Line 1252  for dir in $TESTDIRS ; do Line 1314  for dir in $TESTDIRS ; do
1314      results=$EMPTY_RESULTS      results=$EMPTY_RESULTS
1315    
1316      #  Create an output dir for each OPTFILE/tdir combination      #  Create an output dir for each OPTFILE/tdir combination
1317      rel_CDIR=$DRESULTS"/"$dir      locDIR=$DRESULTS"/"$dir
1318      mkdir $rel_CDIR      mkdir $locDIR
1319      CDIR=`pwd`"/$rel_CDIR"      CDIR=`pwd`"/$locDIR"
1320        
1321      if test "x$CLEANUP" = xt ; then      if test "x$NORUN" = xt ; then
1322          echo '====>>> this is to check that we never go through this part <<< ==='              run=N
1323          makeclean $dir/$builddir \          genmakemodel $dir/$builddir && genmake=Y \
1324              && run_clean $dir/$rundir              && makeclean $dir/$builddir \
1325                && symlink_mpifiles $dir $code_dir $builddir \
1326                && makedependmodel $dir/$builddir && makedepend=Y \
1327                && makemodel $dir/$builddir && make=Y
1328      else      else
1329          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
1330              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
             && run_clean $dir/$rundir \  
1331              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1332              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1333              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1334              && linkdata $dir/$rundir $inputdir input \              && run_clean $dir/$rundir \
1335                && linkdata $dir/$rundir $inputdir \
1336              && runmodel $dir/$rundir && run=Y \              && runmodel $dir/$rundir && run=Y \
1337              && results=`testoutput_run $dir $rundir $ref_outp`              && results=`testoutput_run $dir $rundir $ref_outp`
1338      fi      fi
1339            #echo "results='$results'"
1340      echo  
1341          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1342          echo          echo 1>&2
1343          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1344          touch $CDIR"/summary.txt"          touch $locDIR"/summary.txt"
1345          echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"          echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $locDIR"/summary.txt"
1346          echo "MACH='$MACH'" >> $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $locDIR"/summary.txt"
1347          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $locDIR"/summary.txt"
1348          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $locDIR"/summary.txt"
1349          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $locDIR"/summary.txt"
1350          if test "x$ADM" = xt ; then          if test "x$ADM" = xt ; then
1351              head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"              head -1 $dir/$builddir/taf_ad.log >> $locDIR"/summary.txt"
1352              grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \              grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \
1353                                  >> $CDIR"/summary.txt"                                  >> $locDIR"/summary.txt"
1354          fi          fi
1355    
1356          for ex in $extra_runs ; do          for ex in $extra_runs ; do
# Line 1294  for dir in $TESTDIRS ; do Line 1359  for dir in $TESTDIRS ; do
1359              #  reference output file              #  reference output file
1360              refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`              refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1361              #  Create an output dir for each OPTFILE/tdir.ex combination              #  Create an output dir for each OPTFILE/tdir.ex combination
1362              rel_CDIR=$DRESULTS"/"$dir"."$ex              locDIR=$DRESULTS"/"$dir"."$ex
1363              mkdir $rel_CDIR              mkdir $locDIR
1364              CDIR=`pwd`"/$rel_CDIR"              CDIR=`pwd`"/$locDIR"
1365              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"              test ! -e "$dir/$pfxdir.$ex" && mkdir "$dir/$pfxdir.$ex"
1366              run_clean $dir/tr_run.$ex              run_clean $dir/$pfxdir.$ex
1367              linkdata $dir/tr_run.$ex $inputdir.$ex $inputdir input              linkdata $dir/$pfxdir.$ex $inputdir.$ex $inputdir
1368              runmodel $dir/tr_run.$ex && run=Y \              runmodel $dir/$pfxdir.$ex && run=Y \
1369              && results=`testoutput_run $dir tr_run.$ex $refExOut`              && results=`testoutput_run $dir $pfxdir.$ex $refExOut`
1370              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1371              fres="$fres.$ex"              fres="$fres.$ex"
1372              echo              echo 1>&2
1373              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1374              touch $CDIR"/summary.txt"              touch $locDIR"/summary.txt"
1375              echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"              echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $locDIR"/summary.txt"
1376              echo "MACH='$MACH'" >> $CDIR"/summary.txt"              echo "MACH='$MACH'" >> $locDIR"/summary.txt"
1377              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"              echo "UNAMEA='$UNAMEA'" >> $locDIR"/summary.txt"
1378              echo "DATE='$DATE'" >> $CDIR"/summary.txt"              echo "DATE='$DATE'" >> $locDIR"/summary.txt"
1379              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"              echo "tdir='$dir.$ex'" >> $locDIR"/summary.txt"
1380              if test "x$ADM" = xt ; then              if test "x$ADM" = xt ; then
1381                  head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"                  head -1 $dir/$builddir/taf_ad.log >> $locDIR"/summary.txt"
1382                  grep -A3 'Seconds in section "ALL' $dir/tr_run.$ex/$OUTPUTFILE \                  grep -A3 'Seconds in section "ALL' $dir/$pfxdir.$ex/$OUTPUTFILE \
1383                                     >> $CDIR"/summary.txt"                                     >> $locDIR"/summary.txt"
1384              fi              fi
1385              if test "x$POSTCLEAN" = xt ; then              if test "x$POSTCLEAN" = xt ; then
1386                  run_clean $dir/tr_run.$ex                  run_clean $dir/$pfxdir.$ex
1387              fi              fi
1388          done          done
1389    
1390        if test -f $DRESULTS"/"genmake_state ; then : ; else
1391            if test -f $dir/$builddir/Makefile ; then
1392                mkOpt=`grep '^# OPTFILE=' $dir/$builddir/Makefile 2>/dev/null | head -1 | sed 's/^# //'`
1393                echo "from '$dir/$builddir/Makefile', extract:" > $DRESULTS/genmake_state
1394                sed -n '/^# executed by:/,+1 p' $dir/$builddir/Makefile >> $DRESULTS/genmake_state
1395                echo " $mkOpt" >> $DRESULTS/genmake_state
1396                if test "x$OPTFILE" = xNONE ; then
1397                    eval $mkOpt
1398                    sed "/^No \"OPTFILE\" was specified ; genmake2/a\  OPTFILE=${OPTFILE}"\
1399                            $SUMMARY > tr_0.tmp_log
1400                    RETVAL=$?
1401                    if test "x$RETVAL" = x0 ; then rm -f $SUMMARY
1402                            cp tr_0.tmp_log $SUMMARY
1403                    else rm -f tr_0.tmp_log
1404                    fi
1405                fi
1406                gmkLog=$dir/$builddir/genmake.log
1407                grep '^Get compiler version using:' $gmkLog > /dev/null 2>&1
1408                RETVAL=$?
1409                if test "x$RETVAL" = x0 ; then
1410                    echo "from '$gmkLog', extract compiler version:" >> $DRESULTS/genmake_state
1411                    sed -n '/Get compiler version/,/<-- compiler version/p' $gmkLog \
1412                           | grep -v '^... compiler version ' > tr_1.tmp_log
1413                    sed -n '1,/^$/p' tr_1.tmp_log | sed '/^$/d' | sed 's/^./ &/' \
1414                            >> $DRESULTS/genmake_state
1415                    rm -f tr_1.tmp_log
1416                fi
1417            fi
1418        fi
1419      #postclean $dir/$builddir      #postclean $dir/$builddir
1420      if test "x$POSTCLEAN" = xt ; then      if test "x$POSTCLEAN" = xt ; then
1421          makeclean $dir/$builddir \          makeclean $dir/$builddir \
1422              && run_clean $dir/$rundir              && run_clean $dir/$rundir
1423      fi      fi
1424        
1425      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1426        
1427  done  done
1428    
1429  printf "Start time:  " >> $SUMMARY  printf "Start time:  " >> $SUMMARY
# Line 1358  else Line 1452  else
1452              echo "An email containing results was sent to the following addresses:"              echo "An email containing results was sent to the following addresses:"
1453              echo "  \"$ADDRESSES\""              echo "  \"$ADDRESSES\""
1454              echo              echo
1455                test -f $DRESULTS".tar"  &&  rm -f $DRESULTS".tar"
1456                test -f $DRESULTS".tar.gz"  &&  rm -f $DRESULTS".tar.gz"
1457          fi          fi
         test -f $DRESULTS".tar"  &&  rm -f $DRESULTS".tar"  
         test -f $DRESULTS".tar.gz"  &&  rm -f $DRESULTS".tar.gz"  
1458      fi      fi
1459  fi  fi
1460    
1461  rm -f tr_cmpnum.c tr_cmpnum  if test "x$QUICK" = xf -a "x$NORUN" = xf ; then
1462        rm -f tr_cmpnum.c tr_cmpnum
1463    fi
1464    
1465  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1466      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'

Legend:
Removed from v.1.127  
changed lines
  Added in v.1.152

  ViewVC Help
Powered by ViewVC 1.1.22